
'Xml examples 

'File watch
'<root>
'    <file>
'        <path>c:\temp.tmp</path>
'        <process>1</process>
'    </file>
'</root>

'Registry watch
'<root>
'    <registry>
'        <key>HKCU\Software\Tweakeze\test</key>
'        <name>MyValue</name>
'        <value>1</value>
'        <process>1</process>
'    </registry>
'</root>


Function OnItem(sContext)
	Set oXml = CreateObject("Msxml2.DOMDocument.3.0")
	oXml.loadXML(sContext)
		
	Set oProcessFile = oXml.selectSingleNode("/root/file/process")
	
	if not oProcessFile is Nothing then
		oProcessFile.text = "1"
	End If
	
	Set oProcessRegistry = oXml.selectSingleNode("/root/registry/process")
	if not oProcessRegistry is Nothing then
		oProcessRegistry.text = "1"
		'MsgBox oXml.xml, 0, "VBscript"
	End If		
	
	OnItem = oXml.xml
End Function

'Dim oRes
'oRes = OnItem("<root><file><path>c:\temp.tmp</path><process>100</process></file></root>")
'MsgBox(oRes)
'oRes = OnItem("<root><registry><key>HKCU\\Software\\Tweakeze\\test</key><name>MyValue</name><value>1</value><process>100</process></registry></root>")


Function OnFix(sContext)
	Set oXml = CreateObject("Msxml2.DOMDocument.3.0")
	oXml.loadXML(sContext)
		
	Set oProcessFile = oXml.selectSingleNode("/root/file/process")
	
	if not oProcessFile is Nothing then
		Set oFilename = oXml.selectSingleNode("/root/file/path")
		set fso = CreateObject("Scripting.FileSystemObject")
		'MsgBox(fso.GetExtensionName(oFilename.text))	
		if fso.GetExtensionName(oFilename.text) = "tmp"  then
			'allow fixing for "tmp" files only
			oProcessFile.text = "1"
		else
			oProcessFile.text = "0"
		End if	
	End If
	
	Set oProcessRegistry = oXml.selectSingleNode("/root/registry/process")
	if not oProcessRegistry is Nothing then
		'uncomment to disallow fixing
		'oProcessRegistry.text = "0"
		'MsgBox oXml.xml, 0, "VBscript"
		
		'allow fixing
		oProcessRegistry.text = "0"
	End If		
	
	OnFix = oXml.xml
End Function

'Dim oRes
'oRes = OnFix("<root><file><path>c:\temp.tmp</path><process>100</process></file></root>")
'MsgBox(oRes)
'oRes = OnFix("<root><file><path>c:\temp.log</path><process>100</process></file></root>")
'MsgBox(oRes)
'oRes = OnFix("<root><registry><key>HKCU\\Software\\Tweakeze\\test</key><name>MyValue</name><value>1</value><process>100</process></registry></root>")


'File Change Notification
'<root>
'    <file>
'        <path>c:\temp.tmp</path>
'        <notify>1<notify>
'    </file>
'</root>

'Notification Change type <notify>
'Add 				= 1		==>The file was added to the directory.
'Removed 			= 2 	==>The file was removed from the directory. When a file is renamed to a different directory the client will receive this notification along with MODIFIED.
'Modified 			= 3		==> The file was modified. This can be a change to the data or attributes of the file. When a file is renamed to a different directory the client will receive this notification along with REMOVED.
'Renamed_Old_Name	= 4 	==>The file was renamed, and this is the old name. This notification is only sent when the rename operation does not change the directory the file resides in. The client will also receive a RENAMED_NEW_NAME notification. This notification will not be received if the file is renamed to a different directory.
'Renamed_New_Name	= 5 	==>The file was renamed, and this is the new name. This notification is only sent when the rename operation does not change the directory the file resides in. The client will also receive a RENAME_OLD_NAME notification. This notification will not be received if the file is renamed to a different directory.

Function OnChange(sContext)

	Set oXml = CreateObject("Msxml2.DOMDocument.3.0")
	oXml.loadXML(sContext)
		
	Set oNotifyType = oXml.selectSingleNode("/root/file/notify")
	
	if not oNotifyType is Nothing then
		Set oFilename = oXml.selectSingleNode("/root/file/path")

		if oNotifyType.text = "2" then
			'MsgBox  oFilename.text, 0, "VBscript - File Deleted"
		End If

		if oNotifyType.text = "1" then
			'MsgBox oFilename.text, 0, "VBScript - File Added"
		End If
		
	End If

End Function

'OnChange("<root><file><path>c:\temp.tmp</path><notify>1</notify></file></root>")
'OnChange("<root><file><path>c:\temp.tmp</path><notify>2</notify></file></root>")